Index: GTP/trunk/App/Demos/Vis/CHC_revisited/Bvh.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/Bvh.cpp	(revision 2752)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/Bvh.cpp	(revision 2755)
@@ -2440,149 +832,3 @@
 }
 
-
-float Bvh::GetAvgDepth() const
-{
-	return mAvgDepth;
-}
-
-
-static float GetNodePriority(RenderableHierarchyNode *node)
-{
-	if (node->IsLeaf())
-		return 0.0f;
-
-	float result;
-
-	if (node->GetType() == BVH_NODE)
-	{
-		BvhInterior *interior = static_cast<BvhInterior *>(node);
-		
-		// evaluate the priority of this node
-		const float correctionFactor = 0.0f;
-		//  1.0f*interior->box.FaceArea(node->axis);
-
-		result = 
-			interior->GetBox().getSurface() - 
-			(interior->GetBack()->GetBox().getSurface() + interior->GetFront()->GetBox().getSurface()) + 
-			correctionFactor;
-	}
-	else
-	{
-		TriangleBvhInterior *interior = static_cast<TriangleBvhInterior *>(node);
-		
-		// evaluate the priority of this node
-		const float correctionFactor = 0.0f;
-		//  1.0f*interior->box.FaceArea(node->axis);
-
-		result = 
-			interior->GetBox().getSurface() - 
-			(interior->GetBack()->GetBox().getSurface() + interior->GetFront()->GetBox().getSurface()) + 
-			correctionFactor;
-	}
-
-	return result;
-}
-
-
-struct NodeEntry
-{
-	NodeEntry(RenderableHierarchyNode *node, float p): mNode(node), mPriority(p)
-	{}
-
-	RenderableHierarchyNode *mNode;
-	float mPriority;
-};
-
-
-bool operator<(const NodeEntry &a, const NodeEntry &b)
-{
-	return a.mPriority < b.mPriority;
-}
-
-
-void Bvh::CollectBestNodes(RenderableHierarchyNode *node, HierarchyNodeContainer &nodes)
-{
-	int maxNodes = 32;
-	priority_queue<NodeEntry> nodeStack;
-
-	nodeStack.push(NodeEntry(node, GetNodePriority(node)));
-	nodes.clear();
-
-	float SA = node->GetBox().getSurface();
-	float saThreshold = 1.1f * SA;
-	int numNodes = 1;
-	OUT1(numNodes << " " << SA);
-
-	while (!nodeStack.empty() &&
-		int(nodes.size() + nodeStack.size()) < maxNodes)
-	{
-		NodeEntry entry = nodeStack.top();
-		nodeStack.pop();
-
-		RenderableHierarchyNode *current = entry.mNode;
-
-		if (current->IsLeaf())
-		{
-			// check if there further subdivision on triangle level
-			if ((current->GetType() == BVH_NODE) && (((BvhLeaf *)current)->mTriangleBvh->GetNumNodes() > 1))
-			{
-				// push back the root of the local bvh
-				nodeStack.push(NodeEntry(((BvhLeaf *)current)->mTriangleBvh->GetRoot(), entry.mPriority));
-			}
-			else // terminate traversal
-			{
-				nodes.push_back(current);
-			}
-		}
-		else // interior node
-		{
-			// surface area of child nodes
-			SA -= entry.mPriority;
-		
-			// finish the search if we have too much fillrate increase
-			if (SA > saThreshold)
-			{
-				OUT1("break at " << SA << " > " << saThreshold);
-				nodes.push_back(current);
-			}
-			else
-			{
-				++ numNodes;
-
-				OUT1(numNodes << " " << SA << " " << entry.mPriority);
-
-				if (current->GetType() == BVH_NODE)
-				{
-					BvhInterior *interior = static_cast<BvhInterior *>(current);
-
-					nodeStack.push(NodeEntry(interior->GetBack(), 
-						GetNodePriority(interior->GetBack())));
-					nodeStack.push(NodeEntry(interior->GetFront(),
-						GetNodePriority(interior->GetFront())));
-				}
-				else
-				{
-					TriangleBvhInterior *interior = static_cast<TriangleBvhInterior *>(current);
-
-					nodeStack.push(NodeEntry(interior->GetBack(), 
-						GetNodePriority(interior->GetBack())));
-					nodeStack.push(NodeEntry(interior->GetFront(),
-						GetNodePriority(interior->GetFront())));
-				}
-			}
-		}
-	}
-
-	while (!nodeStack.empty()) 
-	{
-		NodeEntry entry = nodeStack.top();
-	
-		nodeStack.pop();
-		RenderableHierarchyNode *current = entry.mNode;
-		nodes.push_back(current);
-	}
-} 
-
-#endif
-
-}
+}
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/BinaryLoader.h
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/BinaryLoader.h	(revision 2747)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/BinaryLoader.h	(revision 2755)
@@ -4,10 +4,15 @@
 // note use forward declaration instead
 #include <string>
+#include <iostream>
+#include <fstream>
+#include "common.h"
 
 
+namespace CHCDemo
+{
+
 class igzstream;
-class Shape3D;
-class BranchGroup;
-class Appearance;
+class SceneEntity;
+class Material;
 class Geometry;
 
@@ -17,14 +22,18 @@
 public:
 
-	BranchGroup *Load(const std::string &filename);
+	bool Load(const std::string &filename, SceneEntityContainer &geometry);
 
 protected:
+	
+	SceneEntity *LoadShape(std::ifstream &str);
+	Material *LoadMaterial(std::ifstream &str);
+	Geometry *LoadGeometry(std::ifstream &str);
 
-	Shape3D *LoadShape(igzstream &str);
-
-	Appearance *LoadAppearance(igzstream &str);
-
+	/*SceneEntity *LoadShape(igzstream &str);
+	Material *LoadMaterial(igzstream &str);
 	Geometry *LoadGeometry(igzstream &str);
+	*/
 };
 
+}
 #endif
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/Plane3.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/Plane3.cpp	(revision 2751)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/Plane3.cpp	(revision 2755)
@@ -8,7 +8,13 @@
 Plane3::Plane3(const Vector3 &a, const Vector3 &b, const Vector3 &c) 
 {
-    Vector3 v1=a-b, v2=c-b;
-    mNormal = Normalize(CrossProd(v2,v1));
+    Vector3 v1 = a - b, v2 = c - b;
+    mNormal = Normalize(CrossProd(v2, v1));
     mD = -DotProd(b, mNormal);
+}
+
+
+Plane3::Plane3(Vector3 &normal, float dist): 
+mNormal(normal), mD(dist)
+{
 }
 
@@ -28,34 +34,34 @@
 	Vector3 sx(a.mNormal.x, b.mNormal.x, c.mNormal.x),
 		    sy(a.mNormal.y, b.mNormal.y, c.mNormal.y),
-			sz(a.mNormal.z, b.mNormal.z, c.mNormal.z),
-			sd(a.mD, b.mD, c.mD);
+		    sz(a.mNormal.z, b.mNormal.z, c.mNormal.z),
+		    sd(a.mD, b.mD, c.mD);
 
-  Matrix4x4 md(a.mNormal, b.mNormal, c.mNormal), mx, my, mz;
+	Matrix4x4 md(a.mNormal, b.mNormal, c.mNormal), mx, my, mz;
 
-  mx.SetColumns(sd, sy, sz);
-  my.SetColumns(sx, sd, sz);
-  mz.SetColumns(sx, sy, sd);
-  
-  const float det = md.Det3x3();
+	mx.SetColumns(sd, sy, sz);
+	my.SetColumns(sx, sd, sz);
+	mz.SetColumns(sx, sy, sd);
 
-  if (fabs(det) < TRASH)
-    return false;
+	const float det = md.Det3x3();
 
-  result.SetValue(mx.Det3x3()/det,
-				  my.Det3x3()/det,
-				  mz.Det3x3()/det);
-  
-  return true;
+	if (fabs(det) < TRASH)
+		return false;
+
+	result.SetValue(mx.Det3x3()/det,
+		my.Det3x3()/det,
+		mz.Det3x3()/det);
+
+	return true;
 }
 
 
- bool PlaneIntersection(const Plane3 &p1, const Plane3 &p2)
- {
-	 return 
-		 p1.mNormal.x != p2.mNormal.x ||
-		 p1.mNormal.y != p2.mNormal.y ||
-		 p1.mNormal.z != p2.mNormal.z ||
-		 p1.mD == p2.mD;
- }
+bool PlaneIntersection(const Plane3 &p1, const Plane3 &p2)
+{
+	return 
+		p1.mNormal.x != p2.mNormal.x ||
+		p1.mNormal.y != p2.mNormal.y ||
+		p1.mNormal.z != p2.mNormal.z ||
+		p1.mD == p2.mD;
+}
 
 
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/AxisAlignedBox3.h
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/AxisAlignedBox3.h	(revision 2751)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/AxisAlignedBox3.h	(revision 2755)
@@ -3,9 +3,6 @@
 
 
-
 #include "Matrix4x4.h"
 #include "Vector3.h"
-//#include "Plane3.h"
-//#include "Containers.h"
 
 
@@ -14,4 +11,5 @@
 
 struct Triangle3;
+class Plane3;
 
 /** Axis alignedd box class.
@@ -52,5 +50,5 @@
 	const Vector3& Max() const;
 
-	void Enlarge (const Vector3 &v);
+	void Enlarge(const Vector3 &v);
 
 	void EnlargeToMinSize();
@@ -63,6 +61,6 @@
 
 	void SetMax(int axis, const float value);
-
-	// Decrease box by given splitting plane
+	/** Decrease box by given splitting plane
+	*/
 	void Reduce(int axis, int right, float value); 
 
@@ -71,6 +69,6 @@
 	// the size of the box along all the axes
 	Vector3 Size() const;
-	float Radius() const { return 0.5f*Magnitude(Size()); }
-	float SqrRadius() const { return 0.5f*SqrMagnitude(Size()); }
+	float Radius() const { return 0.5f * Magnitude(Size()); }
+	float SqrRadius() const { return 0.5f * SqrMagnitude(Size()); }
 
 	// Return whether the box is unbounded.  Unbounded boxes appear
@@ -84,25 +82,7 @@
 	*/
 	void Include(const int &axis, const float &newBound);
-	// int Side(const Plane3 &plane) const;
-
-	// Overlap returns 1 if the two axis-aligned boxes overlap .. even weakly
-	friend inline bool Overlap(const AxisAlignedBox3 &, const AxisAlignedBox3 &);
-
-	// Overlap returns 1 if the two axis-aligned boxes overlap .. only strongly
-	friend inline bool OverlapS(const AxisAlignedBox3 &,const AxisAlignedBox3 &);
-
-	/** Overlap returns 1 if the two axis-aligned boxes overlap for a given
-	epsilon. If eps > 0.0, then the boxes has to have the real intersection
-	box, if eps < 0.0, then the boxes need not intersect really, they
-	can be at eps distance in the projection.
-	*/
-	friend inline bool Overlap(const AxisAlignedBox3 &,
-		const AxisAlignedBox3 &,
-		float eps);
-
 	/** Includes returns true if a includes b (completely)
 	*/
 	bool Includes(const AxisAlignedBox3 &b) const;
-
 	/** Returns true if this point is inside box.
 	*/
@@ -122,5 +102,5 @@
 	/** Scales the box with the factor.
 	*/
-	void Scale(const float scale);
+	void Scale(float scale);
 
 	void Scale(const Vector3 &scale);
@@ -177,15 +157,32 @@
 
 	int GetFaceVisibilityMask(const Vector3 &position) const;
-	/** Extracts plane of bounding box.
-	*/
-	//Plane3 GetPlane(const int face) const;
 	/** Returns vertex indices of edge.
 	*/
-	void GetEdge(const int edge, int  &aIdx, int &bIdx) const;
-
+	void GetEdge(int edge, int  &aIdx, int &bIdx) const;
+	/** Get distance of plane to vertex with specified index.
+	*/
+	float GetDistance(int index, const Plane3 &plane) const;
+	/** Returns the distance between the plane given by 'vecNearplaneNormal' and the vertex that
+	    is closest to it (this vertex is unequivocally identified by the direction of the vector)
+	*/
+	float GetMinVisibleDistance(const Plane3 &near) const;
 
 
 	////////////
 	//-- friend functions
+
+	/// Overlap returns 1 if the two axis-aligned boxes overlap .. even weakly
+	friend inline bool Overlap(const AxisAlignedBox3 &, const AxisAlignedBox3 &);
+
+	/// Overlap returns 1 if the two axis-aligned boxes overlap .. only strongly
+	friend inline bool OverlapS(const AxisAlignedBox3 &,const AxisAlignedBox3 &);
+
+	/** Overlap returns 1 if the two axis-aligned boxes overlap for a given
+	epsilon. If eps > 0.0, then the boxes has to have the real intersection
+	box, if eps < 0.0, then the boxes need not intersect really, they
+	can be at eps distance in the projection.
+	*/
+	friend inline bool Overlap(const AxisAlignedBox3 &,	const AxisAlignedBox3 &, float eps);
+
 
 	// Returns the smallest axis-aligned box that includes all points
@@ -250,8 +247,16 @@
 	static const int fsvertices[27][9];
 
+	/** Returns the vertex index nearest from the plane specified by the normal.
+	*/
+	static int GetIndexNearestVertex(const Vector3 &vecPlaneNormal);
+	/** Returns the vertwx index farthest from the plane specified by the normal.
+	*/
+	static int GetIndexFarthestVertex(const Vector3 &vecPlaneNormal);
+
+
+
 protected:
 
 	Vector3 mMin, mMax;
-
 };
 
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/CHCTraverser.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/CHCTraverser.cpp	(revision 2755)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/CHCTraverser.cpp	(revision 2755)
@@ -0,0 +1,104 @@
+#include "CHCTraverser.h"
+
+namespace CHCDemo
+{
+
+CHCTraverser::CHCTraverser(): RenderTraverser() 
+{
+}
+
+
+CHCTraverser::~CHCTraverser()
+{
+	//DelQueries();
+}
+
+
+void CHCTraverser::Render()
+{
+#if 0
+	QueryQueue queryQueue;
+
+	//-- PART 1: process finished occlusion queries
+	while (!mDistanceQueue.empty() || !queryQueue.empty())
+	{
+		while (!queryQueue.empty() && 
+			   (ResultAvailable(queryQueue.front()) || mDistanceQueue.empty()))
+		{
+			HierarchyNode *node = queryQueue.front();
+			queryQueue.pop();
+			
+			// wait until result available
+			int visiblePixels = GetOcclusionQueryResult(node);
+
+			if(visiblePixels > mVisibilityThreshold)
+			{
+				PullUpVisibility(node);
+				TraverseNode(node);
+			}
+			else
+			{
+				mNumQueryCulledNodes ++;
+			}
+		}	
+
+		//-- PART 2: hierarchical traversal
+		if (!mDistanceQueue.empty())
+		{
+			HierarchyNode *node = mDistanceQueue.top();
+
+			mDistanceQueue.pop();
+	
+			mNumTraversedNodes ++;
+
+			bool intersects;
+			
+			if (InsideViewFrustum(node, intersects))
+			{
+				// for near plane intersecting bounding box possible 
+				// wrong results => skip occlusion query
+				if(intersects)
+				{
+					// update node's visited flag
+					node->SetLastVisited(mFrameID);
+					node->SetVisible(true);
+					PullUpVisibility(node);
+					TraverseNode(node);
+				}
+				else
+				{		
+					// identify previously visible nodes
+					bool wasVisible = node->Visible() && (node->LastVisited() == mFrameID - 1);
+					
+					// identify nodes that we cannot skip queries for
+					bool leafOrWasInvisible = (node->LastVisited() != mFrameID) && (!wasVisible || node->IsLeaf());
+
+					// reset node's visibility classification 
+					node->SetVisible(false);
+
+					// update node's visited flag
+					node->SetLastVisited(mFrameID);
+					
+					// skip testing previously visible interior nodes
+					if(leafOrWasInvisible)
+					{
+						IssueOcclusionQuery(node, wasVisible);
+						queryQueue.push(node);
+					}
+					
+					// always traverse a node if it was visible
+					if(wasVisible)
+						TraverseNode(node);
+				}
+			}
+			else
+			{
+				// for stats
+				mNumFrustumCulledNodes ++;
+			}
+		}
+	}
+#endif
+}
+
+}
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/Geometry.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/Geometry.cpp	(revision 2751)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/Geometry.cpp	(revision 2755)
@@ -1,11 +1,4 @@
-#if 0
-
-
 #include "Geometry.h"
-#include "glInterface.h"
-#include "stdio.h"
-#include "teapot.h"
-
-#include <math.h>
+#include "Triangle3.h"
 
 
@@ -13,208 +6,40 @@
 {
 
-#define NO_LIST    -1
-#define STRIP_END  -1
+Geometry::Geometry(const TriangleContainer &triangles)
+{}
 
-int Geometry::num_torus_indices;
-int Geometry::num_torus_vertices;
-int Geometry::num_torus_normals;
 
-const int Geometry::torus_precision = 24;
-const int Geometry::sphere_precision = 24;
-
-float *Geometry::torus_vertices;
-float *Geometry::torus_normals;
-int *Geometry::torus_indices;
-
-// choose size so the glut-rendered sphere is approximately
-// as big as the other objects
-const float Geometry::sphere_radius = 1.0 / 9.0f;
-const float Geometry::torus_inner_radius = 0.05;
-const float Geometry::torus_outer_radius = 0.07;
-
-int Geometry::sDisplayList[NUM_OBJECTS];
-
-bool Geometry::sIsInitialised = Init();
-
-Geometry::Geometry(): 
-mXRotation(0), mYRotation(0), mZRotation(0), mScale(1.0), mObjectType(TEAPOT)
+SceneEntity::SceneEntity(Geometry *geometry, 
+						 Matrix4x4 *trafo, 
+						 Material *mat):
+mGeometry(geometry), mTransform(trafo), mMaterial(mat)
 {
-	copyVector3Values(mTranslation, 0, 0, 0);
-	
-	SetAmbientColor(0.1745, 0.01175, 0.01175);
-	SetDiffuseColor(0.61424, 0.04136, 0.04136);
-	SetSpecularColor(0.727811, 0.626959, 0.626959);
-	
-	CalcBoundingVolume();
-	CalcTransform();
-	GenerateList();
-}
-
-Geometry::Geometry(Vector3 translation, float xRot, float yRot, float zRot, float scale, int objectType):
-mXRotation(xRot), mYRotation(yRot), mZRotation(zRot), mScale(scale), mObjectType(objectType)
-{
-	copyVector3(mTranslation, translation);
-
-	SetAmbientColor(0.1745, 0.01175, 0.01175);
-	SetDiffuseColor(0.61424, 0.04136, 0.04136);
-	SetSpecularColor(0.727811, 0.626959, 0.626959);
-	
-	CalcBoundingVolume();
-	CalcTransform();
-	GenerateList();
-}
-
-void Geometry::ResetLists()
-{
-	for(int i = 0; i < NUM_OBJECTS; i++)
-	{
-        if(sDisplayList[i] == NO_LIST)
-			glDeleteLists(sDisplayList[i], 1);
-
-		sDisplayList[i] = NO_LIST;
-	}
-}
-
-void Geometry::CleanUp()
-{
-	ResetLists();
-
-	delete [] torus_vertices;
-	delete [] torus_normals;
-	delete [] torus_indices;
 }
 
 
-bool Geometry::Init()
+void SceneEntity::Render()
 {
-	for(int i=0; i < NUM_OBJECTS; i++)
-		sDisplayList[i] = NO_LIST;
-
-	// parameters chosen so torus is approximately as big as teapot
-	CreateTorus(torus_inner_radius, torus_outer_radius, torus_precision);
-
-	return true;
 }
 
 
-void Geometry::GenerateList()
+void SceneEntity::SetGeometry(Geometry *geom)
 {
-	if(sDisplayList[mObjectType] == NO_LIST)
-	{
-		sDisplayList[mObjectType] = glGenLists(1);
-		glNewList(sDisplayList[mObjectType], GL_COMPILE);
-
-		switch(mObjectType)
-		{
-			case TEAPOT:
-				RenderTeapot();
-				break;
-			case TORUS:
-				RenderTorus();
-				break;
-			case SPHERE:	
-				RenderSphere();
-				break;
-			
-			default:
-				break;
-		}
-
-		glEndList();
-	}
+	mGeometry = geom;
 }
 
 
-void Geometry::Render()
+void SceneEntity::SetTransformation(Matrix4x4 *trafo)
 {
-	glMaterialfv(GL_FRONT, GL_AMBIENT, mAmbientColor);
-	glMaterialfv(GL_FRONT, GL_DIFFUSE, mDiffuseColor);
-	glMaterialfv(GL_FRONT, GL_SPECULAR, mSpecularColor);
-	
-	glPushMatrix();
-	
-	Transform();
-	
-	glCallList(sDisplayList[mObjectType]);
-
-	glPopMatrix();
+	mTransform = trafo;
 }
 
 
-//! sets rotations around the three axis: executed in the order specified here
-void Geometry::SetRotations(float xRot, float yRot, float zRot)
+void SceneEntity::SetMaterial(Material *mat)
 {
-	mXRotation = xRot;
-	mYRotation = yRot;
-	mZRotation = zRot;
-
-	CalcBoundingVolume();
-	CalcTransform();
+	mMaterial = mat;
 }
 
 
-void Geometry::SetTranslation(Vector3 translation)
-{
-	copyVector3(mTranslation, translation);
-
-	CalcBoundingVolume();
-	CalcTransform();
-}
-
-
-void Geometry::SetScale(float scale)
-{
-	mScale = scale;
-	CalcTransform();
-
-	CalcBoundingVolume();
-}
-
-
-void Geometry::SetAmbientColor(float ambientR, float ambientG, float ambientB)
-{
-	mAmbientColor[0] = ambientR;
-	mAmbientColor[1] = ambientG;
-	mAmbientColor[2] = ambientB;
-}
-
-
-void Geometry::SetDiffuseColor(float diffuseR, float diffuseG, float diffuseB)
-{
-	mDiffuseColor[0] = diffuseR;
-	mDiffuseColor[1] = diffuseG;
-	mDiffuseColor[2] = diffuseB;
-}
-
-
-void Geometry::SetSpecularColor(float specularR, float specularG, float specularB)
-{
-	mSpecularColor[0] = specularR;
-	mSpecularColor[1] = specularG;
-	mSpecularColor[2] = specularB;
-}
-
-
-float Geometry::GetScale()
-{
-	return mScale;
-}
-
-
-void Geometry::GetTranslation(Vector3 translation)
-{
-	copyVector3(translation, mTranslation);
-}
-
-
-void Geometry::GetRotations(float &xRot, float &yRot, float &zRot)
-{
-	xRot = mXRotation;
-	yRot = mYRotation;
-	zRot = mZRotation;
-}
-
-	
-const AABox &Geometry::GetBoundingVolume()
+const AxisAlignedBox3& SceneEntity::GetBoundingVolume()
 {
 	return mBoundingBox;
@@ -222,5 +47,5 @@
 
 
-void Geometry::SetLastVisited(int lastVisited)
+void SceneEntity::SetLastVisited(int lastVisited)
 {
 	mLastVisited = lastVisited;
@@ -228,5 +53,5 @@
 
 
-int Geometry::GetLastVisited()
+int SceneEntity::GetLastVisited() const
 {
 	return mLastVisited;
@@ -234,326 +59,3 @@
 
 
-void Geometry::SetObjectType(int type)
-{
-	mObjectType = type;
-	GenerateList();
 }
-
-
-void Geometry::RenderTeapot()
-{
-	int i = 0;
-
-	while(i < num_teapot_indices)
-	{
-		glBegin(GL_TRIANGLE_STRIP);
-		
-		while (teapot_indices[i] != STRIP_END)
-		{	
-			int index = teapot_indices[i] * 3;
-
-			glNormal3fv(teapot_normals + index);
-			glVertex3fv(teapot_vertices + index);
-			
-			++ i;		
-		}
-
-		glEnd();
-
-		++ i; // skip strip end flag
-	}
-}
-
-
-void Geometry::CalcBoundingVolume()
-{
-    switch(mObjectType)
-	{
-		case TORUS:
-			CalcBoundingVolume(torus_vertices, num_torus_vertices);
-			break;
-		case SPHERE:
-			CalcSphereBoundingVolume();
-			break;
-		case TEAPOT:
-			CalcBoundingVolume(teapot_vertices, num_teapot_vertices);
-			break;
-		default:
-			break;
-	}
-}
-
-
-void Geometry::CalcBoundingVolume(float *vertices, const int num_vertices)
-{
-	Vector3 *rotatedPoints = new Vector3[num_vertices];
-	
-	for (int i = 0; i < num_vertices; ++ i)
-	{
-		copyVector3Values(rotatedPoints[i], vertices[i * 3],
-						  vertices[i * 3 + 1], vertices[i * 3 + 2]);
-	
-		rotateVectorZ(rotatedPoints[i], mZRotation * PI_180);
-		rotateVectorY(rotatedPoints[i], mYRotation * PI_180);
-		rotateVectorX(rotatedPoints[i], mXRotation * PI_180);
-	}
-
-	calcCubicHull(mBoundingBox.min, mBoundingBox.max, rotatedPoints, num_vertices);
-
-	for (int i = 0; i < 3; ++ i)
-	{
-		mBoundingBox.min[i] *= mScale;
-		mBoundingBox.max[i] *= mScale;
-	}
-
-	addVector3(mBoundingBox.min, mTranslation, mBoundingBox.min);
-    addVector3(mBoundingBox.max, mTranslation, mBoundingBox.max);
-
-	delete [] rotatedPoints;
-}
-
-
-void Geometry::CalcSphereBoundingVolume()
-{
-	float len = mScale * sphere_radius;
-	Vector3 size = {len, len, len};
-					
-	diffVector3(mBoundingBox.min, mTranslation, size);
-	addVector3(mBoundingBox.max, mTranslation, size);
-}
-
-
-void Geometry::RenderTorus()
-{
-	glVertexPointer(3, GL_FLOAT, sizeof(float), torus_vertices);
-	glEnableClientState(GL_VERTEX_ARRAY);
-
-	glNormalPointer(GL_FLOAT, sizeof(float), torus_normals);
-	glEnableClientState(GL_NORMAL_ARRAY);
-
-    glDrawElements(GL_TRIANGLES, num_torus_indices, GL_UNSIGNED_INT, torus_indices);
-
-	glDisableClientState(GL_VERTEX_ARRAY);
-	glDisableClientState(GL_NORMAL_ARRAY);
-}
-
-/*	Creates a torus with specified radii, with number of rings and ring
-	subdivision = precision.
-*/
-void Geometry::CreateTorus(float innerRadius, float outerRadius, int precision)
-{
-	num_torus_vertices = num_torus_normals = (precision + 1) * (precision + 1);
-	num_torus_indices = 2 * precision * precision * 3;
-
-	torus_vertices = new float[num_torus_vertices * 3];
-	torus_normals = new float[num_torus_normals * 3];
-	torus_indices = new int[num_torus_indices];
-
-	for (int i = 0; i < precision + 1; ++ i)
-	{
-		int index = i * 3;
-
-		Vector3 currentVertex = {innerRadius, 0.0f, 0.0f};
-		rotateVectorZ(currentVertex, ((float)i * 2.0 * PI) / (float)precision);
-
-		currentVertex[0] += outerRadius;
-		
-		Vector3 sTangent = {0.0f, 0.0f, -1.0f};
-		Vector3 tTangent = {0, -1, 0};
-		rotateVectorZ(tTangent, ((float)i * 2.0 * PI) / (float)precision);
-
-      	Vector3 currentNormal;
-
-		cross(currentNormal, tTangent, sTangent);
-
-		torus_normals[index + 0] = currentNormal[0];
-		torus_normals[index + 1] = currentNormal[1];
-		torus_normals[index + 2] = currentNormal[2];
-		
-		torus_vertices[index + 0] = currentVertex[0];
-		torus_vertices[index + 1] = currentVertex[1];
-		torus_vertices[index + 2] = currentVertex[2];
-	}
-
-	for (int i_rng = 1; i_rng < precision + 1; ++ i_rng)
-	{
-		for(int i = 0; i<precision + 1; ++ i)
-		{
-			int index = 3 * (i_rng * (precision + 1) + i);
-
-			Vector3 currentVertex = {torus_vertices[i*3], torus_vertices[i*3+1], torus_vertices[i*3+2]};
-			
-			rotateVectorY(currentVertex, ((float)i_rng * 2.0 * PI) / (float)precision);
-						
-			Vector3 currentNormal = {torus_normals[i*3], torus_normals[i*3+1], torus_normals[i*3+2]};
-			
-			rotateVectorY(currentNormal, ((float)i_rng * 2.0 * PI) / (float)precision);
-
-			torus_normals[index + 0] = currentNormal[0];
-			torus_normals[index + 1] = currentNormal[1];
-			torus_normals[index + 2] = currentNormal[2];
-		
-			torus_vertices[index + 0] = currentVertex[0];
-			torus_vertices[index + 1] = currentVertex[1];
-			torus_vertices[index + 2] = currentVertex[2];
-		}
-	}
-
-	for (int i_rng = 0; i_rng < precision; ++ i_rng)
-	{
-		for (int i = 0; i < precision; ++ i)
-		{
-			int index = ((i_rng * precision + i) * 2) * 3;
-
-			torus_indices[index+0] = (i_rng     * (precision+1) + i)*3;
-			torus_indices[index+1] = ((i_rng+1) * (precision+1) + i)*3;
-			torus_indices[index+2] = (i_rng     * (precision+1) + i + 1)*3;
-
-			index = ((i_rng * precision + i) * 2 + 1) * 3;
-
-			torus_indices[index+0] = (i_rng     * (precision+1) + i + 1)*3;
-			torus_indices[index+1] = ((i_rng+1) * (precision+1) + i)*3;
-			torus_indices[index+2] = ((i_rng+1) * (precision+1) + i + 1)*3;
-		}
-	}
-}
-
-
-/** Counts the triangles of the teapot.
-	traverses through all the triangle strips.
-*/
-int Geometry::CountTeapotTriangles()
-{
-	int result = 0;
-	int i = 0;
-
-	// n - 2 triangles are drawn for a strip
-	while (i < num_teapot_indices)
-	{
-		while (teapot_indices[i] != STRIP_END)
-		{	
-			result ++;;
-			++ i;		
-		}
-		result -= 2;
-		++ i; // skip STRIP_END
-	}
-
-	return result;
-}
-
-
-/**	Counts the triangles of the torus
-*/
-int Geometry::CountTorusTriangles()
-{
-	// every 3 indices specify one triangle
-	return num_torus_indices / 3;
-}
-
-/**
-	counts the triangles of the sphere.
-	sphere_precision / 2 + 1 strips with sphere_precision * 2 - 2 triangles each
-*/
-int Geometry::CountSphereTriangles()
-{
-	return sphere_precision * sphere_precision;
-}
-
-
-int Geometry::CountTriangles(int objectType)
-{
-	int result = 0;
-
-	switch (objectType)
-	{
-		case TEAPOT:
-			result = CountTeapotTriangles();
-			break;
-		case TORUS:
-			result = CountTorusTriangles();
-			break;
-		case SPHERE:	
-			result = CountSphereTriangles();
-			break;
-		default:
-			break;
-	}
-
-	return result;
-}
-
-
-void Geometry::Transform()
-{
-	glMultMatrixd(mTransform);
-}
-
-void Geometry::CalcTransform()
-{
-	Matrix4x4 scale;
-	Matrix4x4 xrot;
-	Matrix4x4 yrot;
-	Matrix4x4 zrot;
-	Matrix4x4 transl;
-
-	makeScaleMtx(scale, mScale, mScale, mScale);
-	makeTranslationMtx(transl, mTranslation);
-	makeRotationXMtx(xrot, mXRotation * PI_180);
-	makeRotationYMtx(yrot, mYRotation * PI_180);
-	makeRotationZMtx(zrot, mZRotation * PI_180);
-
-	copyMatrix(mTransform, IDENTITY);
-	mult(mTransform, mTransform, transl);
-	mult(mTransform, mTransform, xrot);
-	mult(mTransform, mTransform, yrot);
-	mult(mTransform, mTransform, zrot);
-	mult(mTransform, mTransform, scale);
-}
-
-
-/** Renders a sphere with sphere_precision subdivisions. 
-    Note: works only for even sphere_precision
-*/
-void Geometry::RenderSphere()
-{
-	Vector3 vertex;
-
-	// this algorithm renders the triangles clockwise
-	glFrontFace(GL_CW);
-
-	for (int j = 0; j < sphere_precision / 2; ++ j) 
-	{
-		double alpha = j * PI * 2.0 / (double)sphere_precision - PI_2;
-		double beta = (j + 1) * PI * 2.0 / (double)sphere_precision - PI_2;
-
-		glBegin(GL_TRIANGLE_STRIP);
-
-		for (int i = 0; i <= sphere_precision; ++ i) 
-		{
-			double gamma = i * PI * 2.0 / (double)sphere_precision;
-	
-			vertex[0] = sphere_radius * cos(beta) * cos(gamma);
-			vertex[1] = sphere_radius * sin(beta);
-			vertex[2] = sphere_radius * cos(beta) * sin(gamma);
-
-			glNormal3dv(vertex);
-			glVertex3dv(vertex);
-
-			vertex[0] = sphere_radius * cos(alpha) * cos(gamma);
-			vertex[1] = sphere_radius * sin(alpha);
-			vertex[2] = sphere_radius * cos(alpha) * sin(gamma);
-
-		    glNormal3dv(vertex);
-			glVertex3dv(vertex);
-
-		}
-		glEnd();
-	}
-
-	glFrontFace(GL_CCW);
-}
-
-}
-
-#endif
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/chc_revisited.vcproj
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/chc_revisited.vcproj	(revision 2754)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/chc_revisited.vcproj	(revision 2755)
@@ -120,4 +120,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
+				Optimization="3"
 				InlineFunctionExpansion="2"
 				EnableIntrinsicFunctions="true"
@@ -130,4 +131,5 @@
 				RuntimeTypeInfo="false"
 				UsePrecompiledHeader="0"
+				BrowseInformation="1"
 				WarningLevel="3"
 				Detect64BitPortabilityProblems="true"
@@ -205,4 +207,8 @@
 			</File>
 			<File
+				RelativePath=".\Material.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\OcclusionQuery.cpp"
 				>
@@ -247,4 +253,20 @@
 			</File>
 			<File
+				RelativePath=".\BinaryLoader.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\BinaryLoader.h"
+				>
+			</File>
+			<File
+				RelativePath=".\BvhLoader.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\BvhLoader.h"
+				>
+			</File>
+			<File
 				RelativePath=".\common.cpp"
 				>
@@ -256,8 +278,4 @@
 			<File
 				RelativePath=".\glInterface.h"
-				>
-			</File>
-			<File
-				RelativePath=".\Material.cpp"
 				>
 			</File>
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/Camera.h
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/Camera.h	(revision 2753)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/Camera.h	(revision 2755)
@@ -4,7 +4,9 @@
 #include "Vector3.h"
 #include "AxisAlignedBox3.h"
+#include "Plane3.h"
 
 
-namespace CHCDemo {
+namespace CHCDemo 
+{
 
 
@@ -12,5 +14,16 @@
 {
 public:
+	
+	/** Small struct representing a frustum.
+	*/
+	struct Frustum
+	{
+		/// the 6 clip planes
+		//float mClipPlane[6][4];
+		Plane3 mClipPlanes[6];
 
+		void CalcNPVertexIndices(int *indices);
+	};
+	
 	Camera();
 
@@ -34,4 +47,11 @@
 	inline float GetFov() const { return mFovy; }
 	inline void GetSize(int &width, int &height) const { width = mWidth; height = mHeight; }
+	inline float GetAspect() const { return (float) mWidth / mHeight; }
+
+	void GetProjectionMatrix(Matrix4x4 &mat);
+	void GetModelViewMatrix(Matrix4x4 &mat);
+
+	void CalcFrustum(Frustum &frustum);
+
 
 protected:
@@ -50,5 +70,4 @@
 	int mWidth;
 	int mHeight;
-
 };
 
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/Material.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/Material.cpp	(revision 2751)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/Material.cpp	(revision 2755)
@@ -8,4 +8,27 @@
 {
 	return RgbColor(a + Random(b), a + Random(b), a + Random(b));
+}
+
+
+ 
+Material::Material(): mId(0)
+{}
+  
+
+Material::Material(const int id): mId(id)
+{
+}
+
+
+Material::Material(const RgbColor &color):mDiffuseColor(color),
+mAmbientColor(color),
+mSpecularColor(0,0,0), mId(0)
+{
+}
+
+
+int Material::GetId() const
+{
+	return mId;
 }
 
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/CHCPlusPlusTraverser.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/CHCPlusPlusTraverser.cpp	(revision 2755)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/CHCPlusPlusTraverser.cpp	(revision 2755)
@@ -0,0 +1,21 @@
+#include "CHCPlusPlusTraverser.h"
+
+namespace CHCDemo
+{
+
+CHCPlusPlusTraverser::CHCPlusPlusTraverser(): RenderTraverser() 
+{
+}
+
+
+CHCPlusPlusTraverser::~CHCPlusPlusTraverser()
+{
+	//DelQueries();
+}
+
+
+void CHCPlusPlusTraverser::Render()
+{
+}
+
+}
